// Monitor and Soft-Knob 'Control Section'
var frame_control;
var frame_sknob, frame_monitor;
var soft_knobs={};

function animateCtrl()
{
	var y;

	frame_sknob.show();
	while(1)
	{
		for(y=38; y<38+142; y+=15)
		{
			//frame_monitor.moveTo(42,y);
			frame_sknob.moveTo(0, y-38);
			host.sleep(50);
		}
		for(y=38+142; y>38; y-=15)
		{
			//frame_monitor.moveTo(42,y);
			frame_sknob.moveTo(0, y-38);
			host.sleep(50);
		}
	}
}
/*
	sknobsSetOne(4, {angleNrm:this.list.selection/(this.list.count-1)});
		sknobsSetOne(soft_knob_idx, {angle:angl});

		sknobsShow([
			{enabled: true, rot: "RETURN A", push: "OFF"},
			{enabled: true, rot: "ASSIGN", push: "TAKE"},
			{enabled: true, rot: "RETURN B", push: "OFF"},
			{enabled: true, rot: "ASSIGN", push: "TAKE"},
			{enabled: false},
			{enabled: true, rot: "SELECT", push: "PREVIEW"}
		]);
		sknobsSetOne(0, {angleNrm:0});
		sknobsSetOne(3, {angleNrm:0});
		sknobsHide();

*/
// ------------------------- * Soft-Knob Section * -------------------------

function sknobsListNrmPos(list)
{
	var num;

	num=list.count;
	if(num<=1)
		return 0;
	else
		return list.selection/(num-1);
}

/*
** sknobsShow
*/
function sknobsShow(props)
{
	var n, num, p, kn;
	var title;

	title=('title' in props)?props.title:"SOFT CONTROLS";
	if(typeof(title)=='object' && (0 in title) && (1 in title))
	{
		soft_knobs.title_mid.hide();

		soft_knobs.title_duo[0].setText(title[0]);
		soft_knobs.title_duo[1].setText(title[1]);
		soft_knobs.title_duo[0].show();
		soft_knobs.title_duo[1].show();
	}
	else
	{
		soft_knobs.title_duo[0].hide();
		soft_knobs.title_duo[1].hide();
		soft_knobs.title_mid.setText(title);
		soft_knobs.title_mid.show();
	}

// decide on number of knobs
	if(props.length<6)
	{
	// 3 knob variant
		soft_knobs.frm6.hide();
		soft_knobs.frm3.show();
		num=3;
		for(n=0; n<6; n++)
		{
			soft_knobs.sknob[n].enabled=false;
			soft_knobs.sknob[n].list=null;
		}
	}
	else
	{
	// 6 knob variant
		soft_knobs.frm3.hide();
		soft_knobs.frm6.show();
		num=6;
		for(n=6; n<9; n++)
		{
			soft_knobs.sknob[n].enabled=false;
			soft_knobs.sknob[n].list=null;
		}
	}
// set knob properties
	for(n=0; n<num; n++)
	{
		if(!(n in props)) break;
		p=props[n];
		kn=soft_knobs.sknob[num==6?n:n+6];

		kn.enabled=(('enabled' in p) && p.enabled);
		kn.knbg.setIndex(kn.enabled?0:2);
		kn.idx=0;
		if('rot' in p)
		{
			kn.idx|=1;
			kn.rotlb.setText(p.rot);
			kn.rotlb.show();
			kn.kn.show();
		}
		else
		{
			kn.rotlb.hide();
			kn.kn.hide();
		}
		if('push' in p)
		{
			kn.idx|=2;
			kn.pushlb.setText(p.push);
			kn.pushlb.show();
		}
		else
		{
			kn.pushlb.hide();
		}
		kn.bg.setIndex(kn.idx);
		kn.list=('list' in p)?p.list:null;
		if(kn.list) kn.kn.setAngleNrm(sknobsListNrmPos(kn.list));
		kn.enter=('enter' in p) && p.enter;
		kn.jog=('jog' in p) && p.jog;
		kn.updn=('updn' in p) && p.updn;
		kn.ltrt=('ltrt' in p) && p.ltrt;
	}

// hide monitor frame and show soft-knobs
	frame_control.hide();//FIXME!
	frame_monitor.hide();
	frame_sknob.show();
	frame_control.show();//FIXME!
	frame_control.refresh();//FIXME!
}

/*
** sknobsHide
*/
function sknobsHide()
{
// hide soft-knobs and show monitor frame
	frame_sknob.hide();
	frame_monitor.show();
	frame_control.show();//FIXME!
	frame_control.refresh();//FIXME!
}

/*
** sknobsSet
*/
function sknobsSet(props)
{
	var n, p, idx, kn;

	for(n=0; n<9; n++)
	{
		if(!(n in props)) continue;
		p=props[n];
		kn=soft_knobs.sknob[n];

		if('enabled' in p)
		{
			kn.enabled=p.enabled;
			kn.knbg.setIndex(kn.enabled?0:2);
		}

	// values
		if('angle' in p)
			kn.kn.setAngle(p.angle);
		else if('angleNrm' in p)
			kn.kn.setAngleNrm(p.angleNrm);
		if(kn.enabled)
		{
			if('down' in p)
				kn.knbg.setIndex(p.down?1:0);
		}
	// bindings
		if('list' in p)
		{
			kn.list=p.list;
			if(kn.list) kn.kn.setAngleNrm(sknobsListNrmPos(kn.list));
		}
		if('enter' in p) kn.enter=p.enter?true:false;
		if('jog' in p) kn.jog=p.jog?true:false;
		if('updn' in p) kn.updn=p.updn?true:false;
		if('ltrt' in p) kn.ltrt=p.ltrt?true:false;

	// labels
		idx=kn.idx;
		if('rot' in p)
		{
			if(p.rot!=null)
			{
				idx|=1;
				kn.rotlb.setText(p.rot);
				kn.rotlb.show();
				kn.kn.show();
			}
			else if(idx&1)
			{
				idx-=1;
				kn.rotlb.hide();
				kn.kn.hide();
			}
		}
		if('push' in p)
		{
			if(p.push!=null)
			{
				idx|=2;
				kn.pushlb.setText(p.push);
				kn.pushlb.show();
			}
			else if(idx&2)
			{
				idx-=2;
				kn.pushlb.hide();
			}
		}
		if(idx!=kn.idx)
			kn.bg.setIndex(kn.idx=idx);
	}
}

/*
** sknobsSetOne
*/
function sknobsSetOne(n, props)
{
	var v=[];
	v[n]=props;
	sknobsSet(v);
}

function sknobsFindSpecial(special)
{
	var n, kn;

	for(n=0; n<soft_knobs.sknob.length; n++)
	{
		kn=soft_knobs.sknob[n];
		if(kn.enabled && (special in kn) && kn[special])
			return n;
	}
	return special;
}

/*
** sknobsOnRot
*/
function sknobsOnRot(knob, delta)
{
	var page=pages.open;
	var kn, idx;

// check for special cases: knob rotation is bound to jog wheel, up/down or left/right arrows
	if(knob==='jog' || knob==='updn' || knob==='ltrt')
		idx=sknobsFindSpecial(knob);
	else
		idx=knob;

	if(!(idx in soft_knobs.sknob))
	{
	// check for unbound special cases
		switch(idx)
		{
		case 'jog':
			if('onRotaryJog' in page) page.onRotaryJog(delta);
			break;
		case 'updn':
			if('onUpDn' in page) page.onUpDn(-delta);
			break;
		case 'ltrt':
			if('onLtRt' in page) page.onLtRt(delta);
			break;
		}
		return;
	}

	kn=soft_knobs.sknob[idx];
	if(!kn.enabled) return;

	if(kn.list)
	{
		if(knob==='updn') delta=-delta; // reverse, so that Up moves us up
		kn.list.advance(delta);
		kn.kn.setAngleNrm(sknobsListNrmPos(kn.list));
		return;
	}

	if('onSoftKnobRot' in page) page.onSoftKnobRot(idx+1, delta);
}

/*
** sknobsOnDn
*/
function sknobsOnDn(knob)
{
	var page=pages.open;
	var kn, idx;

// check for special cases: knob press is bound to enter
	if(knob==='enter')
		idx=sknobsFindSpecial(knob);
	else
		idx=knob;

	if(!(idx in soft_knobs.sknob))
	{
	// check for unbound special cases
		switch(idx)
		{
		case 'enter':
			if('onEnter' in page) page.onEnter();
			break;
		}
		return;
	}

	kn=soft_knobs.sknob[idx];
	if(!kn.enabled) return;

	if(idx===knob) sknobsSetOne(idx, {down:true});
	if('onSoftKnobDown' in page) page.onSoftKnobDown(idx+1);
}

/*
** sknobsOnUp
*/
function sknobsOnUp(knob)
{
	var page=pages.open;
	var kn, idx;

// check for special cases: knob rotation is bound to jog wheel, up/down or left/right arrows
	if(knob==='enter')
		idx=sknobsFindSpecial(knob);
	else
		idx=knob;

	if(!(idx in soft_knobs.sknob))
	{
	// check for unbound special cases
		return;
	}

	kn=soft_knobs.sknob[idx];
	if(!kn.enabled) return;

	if(idx===knob) sknobsSetOne(idx, {down:false});
	if('onSoftKnobUp' in page) page.onSoftKnobUp(idx+1);
}

/*
** sknobsUpdate
**
** update softknobs rotation angles, using bound list iformation
*/
function sknobsUpdate()
{
	var p, kn;

	for(p in soft_knobs.sknob)
	{
		kn=soft_knobs.sknob[p];
		if(kn.enabled && kn.list)
			kn.kn.setAngleNrm(sknobsListNrmPos(kn.list));
	}
}

/*
** Gui_CreateKnobSection
*/
function Gui_CreateKnobSection(frame)
{
	var n;

	frame_sknob=gui.newFrame(frame, 0, 0, 458, 238, '');
// functions title
	soft_knobs.title_mid   =gui.newLabel(frame_sknob, 161, 32, 128, 15, '', prop_sknob_title);
	soft_knobs.title_mid.hide();
	soft_knobs.title_duo=[];
	soft_knobs.title_duo[0]=gui.newLabel(frame_sknob,  65, 32, 128, 15, '', prop_sknob_title);
	soft_knobs.title_duo[0].hide();
	soft_knobs.title_duo[1]=gui.newLabel(frame_sknob, 257, 32, 128, 15, '', prop_sknob_title);
	soft_knobs.title_duo[1].hide();

	soft_knobs.sknob=[];
	soft_knobs.frm3=gui.newFrame(frame_sknob, 33+3*32, 46, 64*3, 141, '');
	soft_knobs.frm6=gui.newFrame(frame_sknob, 33, 46, 64*6, 141, '');
	for(n=0; n<9; n++)
	{
		var kn=
		{
			enabled: true,	// is knob enabled
			idx:     0,			// background image index
			list:    null,	// associated list
		// alternative controls
			enter:   false, // allow to control this knob with enter key
			jog:     false,	// allow to control this knob with jog wheel
			updn:    false, // allow to control this knob with Up/Down arrows
			ltrt:    false  // allow to control this knob with Left/Right arrows
		};

		if(n<6)
		{
			kn.bg=gui.newPicture(soft_knobs.frm6, n*64, 0, 64, 126, "img/sknob_bg.png");
			kn.lb=gui.newLabel(soft_knobs.frm6, n*64, 126, 64, 15, '', prop_sknob_title);
			kn.lb.setText("F"+(n+1));
		}
		else
		{
			kn.bg=gui.newPicture(soft_knobs.frm3, (n-6)*64, 0, 64, 126, "img/sknob_bg.png");
			kn.lb=gui.newLabel(soft_knobs.frm3, (n-6)*64, 126, 64, 15, '', prop_sknob_title);
			kn.lb.setText("F"+(n-5));
		}

	// knob base with shadow
		kn.knbg=gui.newPicture(kn.bg, 7, 37, 51, 51, "img/sknob_blue.png");
		kn.kn=gui.newKnob(kn.knbg, 12, 12, 26, 26, "img/sknob_line.png");
		kn.rotlb=gui.newLabel(kn.bg, 3, 3, 57, 30, '', prop_sknob_blue);
		kn.rotlb.setText('rotate');

		kn.pushlb=gui.newLabel(kn.bg, 3, 94, 57, 30, '', prop_sknob_blue);
		kn.pushlb.setText('push');

	/* add interactive section */
		kn.knbg.id=n;
		kn.knbg.setInput(true);
		kn.knbg.onMouseDown =function(x, y) {sknobsOnDn(this.id);};
		kn.knbg.onMouseUp   =function(x, y) {sknobsOnUp(this.id);};
		kn.knbg.onMouseWheel=function(x, y, delta) {sknobsOnRot(this.id, -delta);};

		soft_knobs.sknob[n]=kn;
	}

	frame_sknob.hide();
}

// ------------------------- * Monitor Section * -------------------------

/*
** createMonitorMeter
*/
function createMonitorMeter(frame, x, y, id, eng_id)
{
	const mbars=7, mpoints=[-500, 0, 0, 7];
	var mframe, ml, mr;

	mframe=gui.newFrame(frame, x, y, 18, 28, "img/meter_mon.png");
		ml=gui.newMeter(mframe, 0, 0, 9, 28, "img/mbar_mon.png"); ml.setBars(mbars); ml.setPoints(mpoints);
		mr=gui.newMeter(mframe, 9, 0, 9, 28, "img/mbar_mon.png"); mr.setBars(mbars); mr.setPoints(mpoints);
	gui.createMeter(id, 4, null, [ml, mr]);
	gui.linkMeter(id, eng_id);
	host.requestMeter(eng_id, true);
	return mframe;
}

function monitorHideKnob()
{
	if(this.vol_visible==1)
	{
		this.vol_knob.hide();
		this.mute_icon.hide();
		this.met.show();
		this.vol_visible=0;
	}
	this.shwTimeout=null;
}

function monitorUpdateValue()
{
	if(this.vol_visible==0)
	{
		this.mute_icon.hide();
		this.met.hide();
		this.vol_knob.show();
		this.vol_visible=1;
	}
	this.vol_knob.setAngle(this.vol_val/1000*280);
	this.shwTimeout=host.resetTimeout(this.shwTimeout, mon_const.met_restore_time, monitorHideKnob, this);
}

/*
** createMonitorStatus
*/
function createMonitorStatus(frame, x, y, id, eng_id)
{
	var obj={};

	obj.vol_knob=gui.newKnob(frame, x, y, 27, 27, "img/knob_vol.png");
	obj.vol_knob.hide();
	obj.mute_icon=gui.newPicture(frame, x+1, y+1, 25, 25, "img/mute_icon.png");
	obj.mute_icon.hide();
	obj.met=createMonitorMeter(frame, x+6, y+1, id, eng_id);

	obj.vol_val=mon_const.gain_min;
	obj.vol_visible=0;
	obj.ackTimeout=null;
	obj.shwTimeout=null;
	obj.update=monitorUpdateValue;
	return obj;
}

/*
** Gui_CreateMonitorSection
*/
function Gui_CreateMonitorSection(frame, p)
{
	frame_monitor=gui.newFrame(frame, 42, 38, 364, 142, "img/mon_bg.png");

// monitor sources
	p.mon1_src=gui.newLabel(frame_monitor,  44,  7, 85, 19, '', prop_monsrc);
	p.hp_src  =gui.newLabel(frame_monitor,  44, 59, 85, 19, '', prop_monsrc);
	p.mon2_src=gui.newLabel(frame_monitor, 229, 59, 85, 19, '', prop_monsrc);
	p.pvw_src =gui.newLabel(frame_monitor, 229,  7, 85, 19, '', prop_monsrc);
// external sources
	p.ext1_src=gui.newLabel(frame_monitor,  49, 124, 120, 15, '', prop_extsrc);
	p.ext2_src=gui.newLabel(frame_monitor, 236, 124, 120, 15, '', prop_extsrc);
// preview HP mode
	p.prev_hp=gui.newLabel(frame_monitor,   15, 102,  44, 13, '', {font:"myriad-roman-10", color:color_labelOFF, align:align.alignRight});
	p.php_led=gui.newPicture(frame_monitor, 64, 103,  12, 12, "img/led_blue.png");
// monitor volume control
	p.mon1=createMonitorStatus(frame_monitor, 142,  8, mtrGUI.crmo, mtrEng.crmo);
	p.hp  =createMonitorStatus(frame_monitor, 142, 61, mtrGUI.crhp, mtrEng.crhp);
	p.pvw =createMonitorStatus(frame_monitor, 328,  8, mtrGUI.prev, mtrEng.prev);
	p.mon2=createMonitorStatus(frame_monitor, 328, 61, mtrGUI.stmo, mtrEng.stmo);
// monitor DIM indicators
	p.mon1_dim=gui.newPicture(frame_monitor,  37, 30, 16, 8, "img/mon_dim.png");
	p.mon2_dim=gui.newPicture(frame_monitor, 224, 82, 16, 8, "img/mon_dim.png");
	p.mon1_dim.hide();
	p.mon2_dim.hide();

	frame_monitor.hide();
}

/*
** Gui_CreateControlSection
*/
function Gui_CreateControlSection(p)
{
	var f;

	frame_control=gui.newFrame(bgframe, 288, 538, 458, 238, "img/control_frame.png");
	frame_control.hide();

	Gui_CreateKnobSection(frame_control);
	Gui_CreateMonitorSection(frame_control, p);

	frame_control.show();

//	host.setTimeout(1000, animateCtrl);
}
