// Next Generation universal phone interface for Element

function phParseUrl(url)
{
	var res={};
	var n;

	n=url.indexOf('@');
	if(n<0)
		res.host=url;
	else
	{
	/* parse user:pass */
		res.user=url.substring(0, n);
		res.host=url.substring(n+1);
		n=res.user.indexOf(':');
		if(n>=0)
		{
			res.pass=res.user.substring(n+1);
			res.user=res.user.substring(0, n);
		}
	}
/* find out studio */
	n=res.host.indexOf('/');
	if(n>=0)
	{
		res.studio=res.host.substring(n+1);
		res.host=res.host.substring(0, n);
	}
	return res;
}

// ------------------------- * Phone Protocol Proxy * -------------------------

function makeVXproxy(cid, host, login, pass)
{
	var proxy=
	{
		BlockAllToggle: function() {vxCmndBlockAllToggle(this.cid);},
		Xfer: function() {/* not implemented in VX */},
		Next: function() {vxCmndNext(this.cid);},
		Mute: function(mute) {vxCmndMute(this.cid, mute);},
		HybridDrop: function(hybrid) {vxCmndHybridDrop(this.cid, hybrid);},
		HybridHold: function(hybrid) {vxCmndHybridHold(this.cid, hybrid);},
		LineSeize: function(line, hybrid) {vxCmndLineSeize(this.cid, line, hybrid);},
		LineDrop: function(line) {vxCmndLineDrop(this.cid, line);},
		LineHold: function(line) {vxCmndLineHold(this.cid, line);},
		LineCall: function(line, number, hybrid) {vxCmndLineCall(this.cid, line, number, hybrid);},
		LineTake: function(line, hybrid) {vxCmndLineTake(this.cid, line, hybrid);},
		LineLock: function(line) {vxCmndLineLock(this.cid, line);},
		LineUnlock: function(line) {vxCmndLineUnlock(this.cid, line);},
		LineDTMF: function(line, keycode) {vxCmndLineDTMF(this.cid, line, keycode);},

		FixedGetState: function(hybrid) {return vxCmndFixedGetState(this.cid, hybrid);},

		FixedSeize: function(hybrid) {vxCmndFixedSeize(this.cid, hybrid);},
		FixedDrop: function(hybrid) {vxCmndFixedDrop(this.cid, hybrid);},
		FixedHold: function(hybrid) {vxCmndFixedHold(this.cid, hybrid);},
		FixedCall: function(hybrid, number) {vxCmndFixedCall(this.cid, hybrid, number);},
		FixedTake: function(hybrid) {vxCmndFixedTake(this.cid, hybrid);},
		FixedLock: function(hybrid) {vxCmndFixedLock(this.cid, hybrid);},
		FixedUnlock: function(hybrid) {vxCmndFixedUnlock(this.cid, hybrid);},
		FixedDTMF: function(hybrid, keycode) {vxCmndFixedDTMF(this.cid, hybrid, keycode);},

// FIXME: this is wrong
		connect: function(studio, show, showpass) {vxConnect(this.cid, this.host, this.login, this.pass, studio, show);},
		close: function() {vxConnect(this.cid, "", "", "", "", "");},

		cid: cid,
		host: host,
		login: login,
		pass: pass
	};
	return proxy;
}

function makeAPproxy(cid, host, login, pass)
{
	var proxy=
	{
		BlockAllToggle: function() {apCmndBlockAllToggle(this.cid);},
		Xfer: function() {apCmndTransfer(this.cid);},
		Next: function() {apCmndNext(this.cid);},
		Mute: function(mute) {apCmndMute(this.cid, mute);},
		HybridDrop: function(hybrid) {apCmndHybridDrop(this.cid, hybrid);},
		HybridHold: function(hybrid) {apCmndHybridHold(this.cid, hybrid);},
		LineSeize: function(line, hybrid) {apCmndLineSeize(this.cid, line, hybrid);},
		LineDrop: function(line) {apCmndLineDrop(this.cid, line);},
		LineHold: function(line) {/* not implemented in AP */},
		LineCall: function(line, number, hybrid) {apCmndLineCall(this.cid, line, number, hybrid);},
		LineTake: function(line, hybrid) {apCmndLineTake(this.cid, line, hybrid);},
		LineLock: function(line) {apCmndLineLock(this.cid, line);},
		LineUnlock: function(line) {apCmndLineUnlock(this.cid, line);},
		LineDTMF: function(line, keycode) {},

		FixedMap: function(hybrid, line) {apCmndFixedRegister(this.cid, hybrid, line);},
		FixedGetState: function(hybrid) {return apCmndFixedGetState(this.cid, hybrid);},

		FixedSeize: function(hybrid) {apCmndFixedSeize(this.cid, hybrid);},
		FixedDrop: function(hybrid) {apCmndFixedDrop(this.cid, hybrid);},
		FixedHold: function(hybrid) {apCmndFixedHold(this.cid, hybrid);},
		FixedCall: function(hybrid, number) {apCmndFixedCall(this.cid, hybrid, number);},
		FixedTake: function(hybrid) {apCmndFixedTake(this.cid, hybrid);},
		FixedLock: function(hybrid) {apCmndFixedLock(this.cid, hybrid);},
		FixedUnlock: function(hybrid) {apCmndFixedUnlock(this.cid, hybrid);},
		FixedDTMF: function(hybrid, keycode) {},

// FIXME: this is wrong
		connect: function(studio, show, showpass) {apConnect(this.cid, this.host, this.login, this.pass, show, showpass, studio, 0);},
		close: function() {apConnect(this.cid, "", "", "", "", "", "", 0);},

		cid: cid,
		host: host,
		login: login,
		pass: pass
	};
	return proxy;
}

function getPhProxy(cid, host, login, pass)
{
	if(host=="") return null;

	if(host.substr(0, 3)=="vx:")
		return makeVXproxy(cid, host.substr(3), login, pass);
	else
		return makeAPproxy(cid, host, login, pass);
}

function getPhProxyUrl(cid, url)
{
	var ci;
	if(url=="") return null;

	if(url.substr(0, 3)=="vx:")
	{
		ci=phParseUrl(url.substr(3));
		if(!('host' in ci) || ci.host=="") return null;
		if(!('user' in ci)) ci.user='user'; // default VX user
		if(!('pass' in ci)) ci.pass='';     // default VX password

		return makeVXproxy(cid, ci.host, ci.user, ci.pass);
	}
	else
	{
		if(url.substr(0, 3)=="ap:") url=url.substr(3);
		ci=phParseUrl(url);
		if(!('host' in ci) || ci.host=="") return null;
		if(!('user' in ci)) ci.user='telos'; // default Nx user
		if(!('pass' in ci)) ci.pass='telos'; // default Nx password
		return makeAPproxy(cid, ci.host, ci.user, ci.pass);
	}
}

// ------------------------- * Phone Controller Channels (aka US Phone) * -------------------------
const phUS_maxnum=15;	// total number of US phone channels
var phUS_ConnInfo=[];

/*
** phUS_UpdateConnectionData
**
** updates complete connection data for given CallController
** ccid: call controller id
*/
function phUS_UpdateConnectionData(ccid, url, show, shhost, shpass, lnmode, hyrev)
{
	var line, phUS;

	if(ccid in phUS_ConnInfo)
	{
	/* there is existing connection; close it before opening new */
		if('pp' in phUS_ConnInfo[ccid])
		{
			phUS_ConnInfo[ccid].pp.close();
			delete phUS_ConnInfo[ccid].pp;
		}
	/* release all GUI Elements we might own */
		gui_indi.inringClose(phUS_ConnInfo[ccid]);
		gui_indi.numpadRelease(phUS_ConnInfo[ccid]);
		phUS_TakeLineClear(phUS_ConnInfo[ccid]);

		delete phUS_ConnInfo[ccid];
	// -- clear icons
		for(line=1; line<24; line++)
			mod.setPhoneIcon(ccid, line, 0);
	}
	if(url=="")
	{
	// not configured; clear 1st icon too and forget about it
		mod.setPhoneIcon(ccid, 0, 0);
		return;
	}
	mod.setPhoneIcon(ccid, 0, icons.RectSpin); // set connection in progress icon

	phUS=
	{
		id: ccid,
	/* dialpad servicing functions */
		onPadEnter: phUS_onPadEnter,
		onPadClose: phUS_onPadClose,
		onPadKey  : phUS_onPadKey,
		state:  'idle', // connection state: idle, connect, working, error
		faders:  {},    // array of faders assigned to this connection
		map_hyb: {},    // mapping of sel hybrid -> fader channel
		map_fix: {},    // mapping of fix hybrid -> fader channel
		takehyb: -1,    // take line hybrid, -1 if none
		take_to: null,  // take line timeout, 10seconds
		ringline:null,  // incoming call which triggered frame, when not ringing anymore close frame
		lines:   [],    // selectable line states from protocol
		num_hybrids:0,  // number of selectable hybrids
		num_lines:0,    // number of selectable lines
		num_fixed:0,    // number of fixed hybrids
		fixeds:  [],    // fixed line states from protocol
		mode24: false   // mode of operation 12/24 lines
	};
	phUS.pp=getPhProxyUrl(ccid, url);
	if(phUS.pp==null)
	{
	// not configured; clear 1st icon too and forget about it
		mod.setPhoneIcon(ccid, 0, icons.CrossBig);
		return;
	}
	phUS.cinfo=
	{
		url   : url,
		studio: shhost,
		show  : show,
		shpass: shpass,
		lnmode: lnmode,
		hyrev : hyrev
	};
	phUS_ConnInfo[ccid]=phUS;
	phUS_Connect(phUS);
}

/*
** phUS_UpdateChnInfo
**
** called when USphone channel configuration is changed
** we need to:
** - close all active phone connectons
** - clean all modules from leftover icons
** - parse new phone configuration; format is: "<host>,<user>,<pass>"
** - send new configuration to ACL
** - wait for further instructions from ACL's profile about connection parameters
*/
function phUS_UpdateChnInfo(ph_config)
{
	var phmsg={id:'WRNI'};
	var n, chn;

	for(n in ph_config)
	{
		if(ph_config[n]==null) continue;
		chn=parseInt(n)+1;
		phmsg[host.sprintf("sCH%02d", chn)]=ph_config[n];
	}
	return phmsg;
}

function phUS_UpdateChnInfoEx(ph_config)
{
	var phmsg={id:'WRNI'};
	var n, chn, line;
	var params;

/* populate connection list */
	for(n=0; n<phUS_maxnum; n++)
	{
		chn=n+1;
	/* delete previous connection information */
		if(chn in phUS_ConnInfo)
		{
			if('pp' in phUS_ConnInfo[chn])
			{
				phUS_ConnInfo[chn].pp.close();
				delete phUS_ConnInfo[chn].pp;
			}
		/* release all GUI Elements we might own */
			gui_indi.inringClose(phUS_ConnInfo[chn]);
			gui_indi.numpadRelease(phUS_ConnInfo[chn]);
			phUS_TakeLineClear(phUS_ConnInfo[chn]);
			delete phUS_ConnInfo[chn];
		}

		if(!(n in ph_config) || ph_config[n]==null) continue;

	// channel is 'captured' (enabled)
	// -- clear icons
		for(line=1; line<24; line++)
			mod.setPhoneIcon(chn, line, 0);

	// -- get IP connection parameters
		params=ph_config[n].split(",");
		if(params.length<3 || params[0]=="")
		{
		// channel captured, but not configured; clear 1st icon too and forget about it
			mod.setPhoneIcon(chn, 0, 0);
			continue;
		}

	// channel captured and configured
		phUS_ConnInfo[chn]=
		{
			id: chn,
		/* dialpad servicing functions */
			onPadEnter: phUS_onPadEnter,
			onPadClose: phUS_onPadClose,
			onPadKey  : phUS_onPadKey,
			state:  'idle', // connection state: idle, connect, working, error
			faders:  {},    // array of faders assigned to this connection
			map_hyb: {},    // mapping of sel hybrid -> fader channel
			map_fix: {},    // mapping of fix hybrid -> fader channel
			takehyb: -1,    // take line hybrid, -1 if none
			take_to: null,  // take line timeout, 10seconds
			ringline:null,  // incoming call which triggered frame, when not ringing anymore close frame
			lines:   [],    // selectable line states from protocol
			num_hybrids:0,  // number of selectable hybrids
			num_lines:0,    // number of selectable lines
			num_fixed:0,    // number of fixed hybrids
			fixeds:  [],    // fixed line states from protocol
			mode24: false   // mode of operation 12/24 lines
		};
		phUS_ConnInfo[chn].pp=getPhProxy(chn, params[0], params[1], params[2]);
		mod.setPhoneIcon(chn, 0, icons.RectSpin); // set connection in progress icon
		phmsg[host.sprintf("sCH%02d", chn)]=ph_config[n];

		log.info_f("DBG: Phone channel %d: '%s', '%s', '%s'", chn, params[0], params[1], params[2]);
	}

	return phmsg;
}

/*
** phUS_UpdateShowInfo
**
** called when new show info is received from ACL
**
** cmsg sample: {id:"NEST", mCH01:{id:"INDI", sPURL:"user:pass@192.168.0.38", sPSWN:"Hybrid1&2", sHOST:"TWOx12", sPSWD:"", bHYBM:0, bPMOD:0}};
*/
function phUS_UpdateShowInfo(cmsg)
{
	var n, chn;
	var ph_config, sh_config;

	ph_config=mod.getPhoneConfig();
	for(n in ph_config)
	{
		if(ph_config[n]==null) continue;
		chn=parseInt(n)+1;

		sh_config=(txtChn[chn] in cmsg)?cmsg[txtChn[chn]]:null;
		if(sh_config==null
		|| !('sPSWN' in sh_config) || !('sPSWD' in sh_config) || !('sHOST' in sh_config)
		|| !('bPMOD' in sh_config) || !('bHYBM' in sh_config) || !('sPURL' in sh_config))
		{
			phUS_UpdateConnectionData(chn, "", "", "", "", 'Auto', false);
		}
		else
		{
			phUS_UpdateConnectionData(chn, sh_config.sPURL, sh_config.sPSWN, sh_config.sHOST, sh_config.sPSWD, (sh_config.bPMOD==0)?'Auto':(sh_config.bPMOD==1?'12':'24'), (sh_config.bHYBM!=0));
		}
	}
}

function phUS_UpdateShowInfoEx(cmsg)
{
	var chn;
	var sh_config;
	var phUS;

	for(chn=1; chn<=phUS_maxnum; chn++)
	{
		if(!(chn in phUS_ConnInfo)) continue; // no such channel in capture profile
		phUS=phUS_ConnInfo[chn];

		sh_config=(txtChn[chn] in cmsg)?cmsg[txtChn[chn]]:null;
		if(sh_config==null
		|| !('sPSWN' in sh_config) || !('sPSWD' in sh_config) || !('sHOST' in sh_config)
		|| !('bPMOD' in sh_config) || !('bHYBM' in sh_config))
		{
		/* no data was received from ACL about this channel, if connection exists we should close it */
			phUS.cinfo=
			{
				studio: "",
				show  : "",
				shpass: "",
				lnmode: 'Auto',
				hyrev : false
			};

			if(phUS.state=='idle')
			{
			/* we are idle, nothing to do here */
				mod.setPhoneIcon(chn, 0, 0);
				continue; 
			}
		}
		else
		{
		/* grab all the parameters we need */
			phUS.cinfo=
			{
				studio: sh_config.sHOST,
				show  : sh_config.sPSWN,
				shpass: sh_config.sPSWD,
				lnmode: (sh_config.bPMOD==0)?'Auto':(sh_config.bPMOD==1?'12':'24'),
				hyrev : (sh_config.bHYBM!=0)
			};
		}
		if(phUS.state=='working' && phUS_StartWaitingFaders(phUS))
			continue; // cann't connect to show just yet, wait till all faders go off
		phUS_Connect(phUS);
	}
}

/*
** phUS_Connect
**
** open connection to phone show
*/
function phUS_Connect(phUS)
{
	var line;

	if(phUS.state!='idle')
	{
	/* release all GUI Elements we might own */
		gui_indi.inringClose(phUS);
		gui_indi.numpadRelease(phUS);
		phUS_TakeLineClear(phUS);
	/* close existing connection */
		phUS.pp.close();
	/* TODO: clear studio data */
	}

	if(phUS.cinfo.studio=="" && phUS.cinfo.show=="")
	{
	/* clear icons */
		for(line=0; line<24; line++)
			mod.setPhoneIcon(phUS.id, line, 0);
		phUS.state='idle';
		return;
	}

	mod.setPhoneIcon(phUS.id, 0, icons.RectSpin); // set connection in progress icon
	for(line=1; line<24; line++)
		mod.setPhoneIcon(phUS.id, line, 0);
	phUS.state='connect';
	phUS.lnmode=phUS.cinfo.lnmode;
	phUS.hyrev =phUS.cinfo.hyrev;
	phUS.pp.connect(phUS.cinfo.studio, phUS.cinfo.show, phUS.cinfo.shpass);
}

/*
** phUS_StartWaitingFaders
**
** starts monitoring phone faders
** returns true if there are faders to wait
*/
function phUS_StartWaitingFaders(phUS)
{
	var c;
	var count=0;

	for(c in phUS.faders)
		if(ch_data[c].onsw)
	{
		phUS.faders[c].waiting=true;
		count++;
	}

	if(count>0)
	{
		gui_indi.setPhoneShowWaiting(true);
		return true;
	}
	return false;
}

/*
** phUS_CheckWaitingFaders
**
** checks if all monitoring faders were transitioned to off state
*/
function phUS_CheckWaitingFaders(phUS)
{
	var c;

	for(c in phUS.faders)
		if(phUS.faders[c].waiting)
			return;
/* free to connect */
	gui_indi.setPhoneShowWaiting(false);
	phUS_Connect(phUS);
}

/*
** phUS_UpdateFaderData
**
** this function is called to update fader - hybrid mapping
** in case of disabled phone phone_id is 0
*/
function phUS_UpdateFaderData(channel, phone_id, hybrid, fixed_line, mashing)
{
	var phUS, p;

	log.info_f("phUS_UpdateFaderData: ch%02d, phid=%d, hyb=%d, fixln=%d, mash=%s", channel, phone_id, hybrid, fixed_line, mashing?'yes':'no');

/* first clear this fader data */
	for(p in phUS_ConnInfo)
	{
		if(!(channel in phUS_ConnInfo[p].faders)) continue;
		phUS=phUS_ConnInfo[p];
		if(phUS.faders[channel].fixed_line==0)
			delete phUS.map_hyb[phUS.faders[channel].hybrid];
		else
		{
			if('FixedMap' in phUS.pp) phUS.pp.FixedMap(phUS.faders[channel].hybrid, null);
			delete phUS.map_fix[phUS.faders[channel].hybrid];
		}
		if(phUS.faders[channel].waiting)
		{
		/* was waiting for that fader; not anymore */
			delete phUS.faders[channel];
			phUS_CheckWaitingFaders(phUS);
		}
		else
			delete phUS.faders[channel];
	}

	if(!(phone_id in phUS_ConnInfo)) return false;
	phUS=phUS_ConnInfo[phone_id];

	if(fixed_line==0)
	{
		if((hybrid in phUS.map_hyb) && phUS.map_hyb[hybrid]!=channel)
		{
			log.warning_f("phUS-%d: sel hybrid %d is already on fader %d (request to %d)", phone_id, hybrid, phUS.map_hyb[hybrid], channel);
			return false;
		}
	}
	else
	{
		if((hybrid in phUS.map_fix) && phUS.map_fix[hybrid]!=channel)
		{
			log.warning_f("phUS-%d: fix hybrid %d is already on fader %d (request to %d)", phone_id, hybrid, phUS.map_fix[hybrid], channel);
			return false;
		}
	}

	phUS.faders[channel]=
	{
		waiting: false, /* true if waiting for this fader to go off to load new config */
		hybrid: hybrid,
		fixed_line: fixed_line,
		mashing: mashing
	};
	if(fixed_line==0)
	{
		phUS.map_hyb[hybrid]=channel;
		phUS_UpdateFader(phUS, channel, hybrid);
	}
	else
	{
		phUS.map_fix[hybrid]=channel;
		if('FixedMap' in phUS.pp) phUS.pp.FixedMap(hybrid, fixed_line-1);
		phUS.fixeds[hybrid]=phUS.pp.FixedGetState(hybrid);
		phUS_UpdateFixedFader(phUS, channel, hybrid);
	}
	return true;
}

function phUS_IndiStudioCfg(phone_id, num_lines, num_hybrids, num_fixed)
{
	if(!(phone_id in phUS_ConnInfo)) return;
	var phUS=phUS_ConnInfo[phone_id];
	var n;

	phUS.num_hybrids=num_hybrids;
	phUS.num_fixed=num_fixed;

	switch(phUS.lnmode)
	{
	case '12':
		phUS.mode24=false;
		break;
	case '24':
		phUS.mode24=true;
		break;
	case 'Auto':
	default:
		phUS.mode24=(num_lines>12);
		break;
	}
/* limit number of lines we can display */
	phUS.num_lines=clamp(num_lines, 0, phUS.mode24?24:12);
/* draw line icons */
	if(phUS.mode24)
	{
		for(n=0; n<phUS.num_lines; n++)
			mod.setPhoneIcon(phone_id, n, 0);
		for(; n<24; n++)
			mod.setPhoneIcon(phone_id, n, 0);
	}
	else
	{
		for(n=0; n<phUS.num_lines; n++)
		{
			mod.setPhoneIcon(phone_id, n, 0);
			mod.setPhoneIcon(phone_id, n+12, 0);
		}
		for(; n<12; n++)
		{
			mod.setPhoneIcon(phone_id, n, 0);
			mod.setPhoneIcon(phone_id, n+12, 0);
		}
	}
/* initialize line structure */
	phUS.ringline=null;
	phUS.lines=[];
	for(n=0; n<phUS.num_lines; n++)
	{
		phUS.lines[n]=
		{
			state:  'NONE',
			hybrid: 0,
			remote: ''
		};
	}
	for(n=1; n<=phUS.num_fixed; n++)
	{
		phUS.fixeds[n]=
		{
			state: 'NONE',
			remote: ''
		};
	}
/* reset fader status */
	for(n in phUS.faders)
		if(phUS.faders[n].fixed_line==0)
			phUS_UpdateFader(phUS, n, phUS.faders[n].hybrid);
		else
			phUS_UpdateFixedFader(phUS, n, phUS.faders[n].hybrid);
}

/*
** phUS_UpdateFader
*/
function phUS_UpdateFader(phUS, channel, hybrid)
{
	var line;
	var text="";

	for(line in phUS.lines)
		if(phUS.lines[line].hybrid==hybrid)
	{
		if(text!="")
		{
			text="Multiple";
			break;
		}
		if(true || phUS.lines[line].remote=="")
			text=("Line "+(parseInt(line)+1));
		else
			text=phUS.lines[line].remote;
	}
	if(phUS.takehyb!=hybrid) setChnPhoneText(channel, text);
	setChnPhoneOnAir(channel, text!="");
	setChnPhoneLed(channel, (text!="")?255:0);
}

function ph_UpdateFixedFader(channel, ln)
{
	var icon=0, on_air=false, style=0;

	switch(ln.state)
	{
	case 'NONE':
	default:
		break;
	case 'IDLE':
		icon=icons.Dot;
		break;
	case 'SEIZED':
		icon=icons.RectStat;
		style=255;
		break;
	case 'RINGING_IN':
		icon=icons.Ringing;
		style=6; /* wink */
		break;
	case 'ON_AIR':
		icon=icons.ArrowDn;
		on_air=true;
		style=255;
		break;
	case 'ON_AIR_DIALING':
		icon=icons.RectSpin;
		on_air=true;
		style=255;
		break;
	case 'ON_AIR_LOCKED':
		icon=icons.LockLt;
		on_air=true;
		style=255;
		break;
	case 'ON_HANDSET':
		icon=icons.Handset;
		break;
	case 'ON_HOLD':
		icon=icons.OnHold;
		break;
	case 'ON_HOLD_READY':
		icon=icons.CheckBig;
		break;
	case 'BUSY':
		icon=icons.CrossBig;
		break;
	case 'SEIZED_EW':
	case 'ON_HANDSET_EW':
	case 'USED_EW':
		icon=icons.CrossSml;
		break;
	}
	setChnPhoneIcon(channel, icon);
	setChnPhoneOnAir(channel, on_air);
	setChnPhoneLed(channel, style);
}

/*
** phUS_UpdateFixedFader
*/
function phUS_UpdateFixedFader(phUS, channel, hybrid)
{
	ph_UpdateFixedFader(channel, phUS.fixeds[hybrid]);
}

/*
** phUS_IndiLineState
*/
function phUS_IndiLineState(phone_id, line, state, hybrid, remote)
{
	if(!(phone_id in phUS_ConnInfo)) return;
	var phUS=phUS_ConnInfo[phone_id];
	var icon=0, ico_hyb=0;
	var ln, hyb_lt;
	var old_hybrid, old_state, old_remote;

	if(!(line in phUS.lines)) return;
	ln=phUS.lines[line];

/* is hybrid a left hybrid */
	hyb_lt=(hybrid==1);
	if(phUS.hyrev) hyb_lt=!hyb_lt; /* hybrid is reversed */

	switch(state)
	{
	case 'NONE':
	default:
		break;
	case 'IDLE':
		icon=icons.Dot;
		break;
	case 'SEIZED':
		icon=icons.RectStat;
		ico_hyb=hyb_lt?-1:1;
		break;
	case 'RINGING_IN':
		icon=icons.Ringing;
		break;
	case 'ON_AIR':
		icon=hyb_lt?icons.ArrowLt:icons.ArrowRt;
		ico_hyb=hyb_lt?-1:1;
		break;
	case 'ON_AIR_DIALING':
		icon=icons.RectSpin;
		ico_hyb=hyb_lt?-1:1;
		break;
	case 'ON_AIR_LOCKED':
		icon=hyb_lt?icons.LockLt:icons.LockRt;
		ico_hyb=hyb_lt?-1:1;
		break;
	case 'ON_HANDSET':
		icon=icons.Handset;
		break;
	case 'ON_HOLD':
		icon=icons.OnHold;
		break;
	case 'ON_HOLD_READY':
		icon=icons.CheckBig;
		break;
	case 'BUSY':
		icon=icons.CrossBig;
		break;
	case 'SEIZED_EW':
	case 'ON_HANDSET_EW':
	case 'USED_EW':
		icon=icons.CrossSml;
		break;
	}
	if(phUS.mode24)
		mod.setPhoneIcon(phone_id, line, icon);
	else
	{
		if(ico_hyb<0)
		{
		/* icon corresponds to left hybrid, leave right icon dark */
			mod.setPhoneIcon(phone_id, line, icon);
			mod.setPhoneIcon(phone_id, line+12, 0);
		}
		else if(ico_hyb>0)
		{
		/* icon corresponds to right hybrid, leave right icon dark */
			mod.setPhoneIcon(phone_id, line, 0);
			mod.setPhoneIcon(phone_id, line+12, icon);
		}
		else
		{
		/* icon is hybrid neutral, show on both */
			mod.setPhoneIcon(phone_id, line, icon);
			mod.setPhoneIcon(phone_id, line+12, icon);
		}
	}

/* process state change */
	if(state!=ln.state)
	{
		if(state=='RINGING_IN')
		{
			phUS.ringline=line;
			gui_indi.inringOpen(phUS, remote);
		}
		else if(line==phUS.ringline)
		{
			phUS.ringline=null;
			gui_indi.inringClose(phUS);
		}
		if(state=='SEIZED')
			gui_indi.numpadGrab(phUS);
		else if(ln.state=='SEIZED')
			gui_indi.numpadRelease(phUS);
	}

/* back-up old state */
	old_hybrid=ln.hybrid; old_state=ln.state; old_remote=ln.remote;
/* store new state info */
	ln.state=state; ln.hybrid=hybrid; ln.remote=remote;

	if(hybrid!=old_hybrid)
	{
		phUS_TakeLineRelease(phUS, hybrid); /* release take line if something appeared on the hybrid */
		if(old_hybrid in phUS.map_hyb) /* line goes off one of our hybrids */
			phUS_UpdateFader(phUS, phUS.map_hyb[old_hybrid], old_hybrid);
		if(hybrid in phUS.map_hyb)
			phUS_UpdateFader(phUS, phUS.map_hyb[hybrid], hybrid);
	}
	else if(ln.remote!=old_remote || ln.state!=old_state)
	{
		if(hybrid in phUS.map_hyb)
			phUS_UpdateFader(phUS, phUS.map_hyb[hybrid], hybrid);
	}
}

function phUS_IndiFixedState(phUS, hybrid, state, remote)
{
	var icon=0, on_air=false;
	var ln;

	if(!(hybrid in phUS.fixeds)) return;
	ln=phUS.fixeds[hybrid];

	if(state==ln.state && remote==ln.remote) return;

/* process state change */
	if(state!=ln.state)
	{
		if(state=='RINGING_IN')
		{
			phUS.ringline=-hybrid;
			gui_indi.inringOpen(phUS, remote);
		}
		else if((-hybrid)==phUS.ringline)
		{
			phUS.ringline=null;
			gui_indi.inringClose(phUS);
		}
		if(state=='SEIZED')
			gui_indi.numpadGrab(phUS);
		else if(ln.state=='SEIZED')
			gui_indi.numpadRelease(phUS);
	}

	ln.state=state;
	ln.remote=remote;
	if(hybrid in phUS.map_fix)
		phUS_UpdateFixedFader(phUS, phUS.map_fix[hybrid], hybrid);
}

// ------------------------- * Take Line * -------------------------

function phUS_TakeLineClear(phUS)
{
	var hyb=phUS.takehyb;

	phUS.takehyb=-1;
	phUS.take_to=host.clearTimeout(phUS.take_to);
	if(hyb in phUS.map_hyb)
		phUS_UpdateFader(phUS, phUS.map_hyb[hyb], hyb);
}

function phUS_TakeLineRelease(phUS, hybrid)
{
	if(phUS.takehyb!=hybrid) return false;
	phUS_TakeLineClear(phUS);
	return true;
}

function phUS_TakeLineActivate(phUS, hybrid)
{
	if(hybrid==1 && !phUS.mode24) return; /* 1st hybrid in 12 line mode is special, it has dedicated button */
	phUS_TakeLineClear(phUS);
	if(hybrid in phUS.map_hyb)
	{
		phUS.takehyb=hybrid;
		phUS.take_to=host.resetTimeout(phUS.take_to, 10000, function(){phUS_TakeLineClear(this);}, phUS);
		setChnPhoneText(phUS.map_hyb[hybrid], "Take Line");
		setChnPhoneLed(phUS.map_hyb[hybrid], 4);
	}
}

function phUS_TakeLineToggle(phUS, hybrid)
{
	if(!phUS_TakeLineRelease(phUS, hybrid))
		phUS_TakeLineActivate(phUS, hybrid);
}

function phUS_HybHasLockedLines(phUS, hybrid)
{
	var line;

	for(line in phUS.lines)
		if(phUS.lines[line].hybrid==hybrid && phUS.lines[line].state=='ON_AIR_LOCKED')
			return true;
	return false;
}

function phUS_HybCanDrop(phUS, hybrid)
{
	var line;

	for(line in phUS.lines)
		if(phUS.lines[line].hybrid==hybrid
		&& (phUS.lines[line].state=='ON_AIR' || phUS.lines[line].state=='ON_AIR_DIALING' || phUS.lines[line].state=='SEIZED'))
			return true;
	return false;
}

/*
** phUS_SelectHybridForLine
*/
function phUS_SelectHybridForLine(phUS, ln, key_lt)
{
	var hyb;

	if(phUS.mode24)
	{
	/* 24 line mode, each line has only 1 key */	
		if(phUS.takehyb in phUS.map_hyb)
			return phUS.takehyb;
		else
			return 1;
	}
	if(key_lt)
		return 1; /* 12 line mode, dedicated left key */
/* 12 line mode, right key */
	if(phUS.takehyb in phUS.map_hyb)
		return phUS.takehyb;
	if(ln.hybrid>1) return ln.hybrid; /* line is already on right hybrid, lock/unlock it */
/* find hybrid following requencable rules */
	for(hyb=2; hyb<=phUS.num_hybrids; hyb++)
	{
		if(!(hyb in phUS.map_hyb)) continue; /* hybrid is not selected on a fader */
	/* no lines locked on it || mashing allowed */
		if(phUS.faders[phUS.map_hyb[hyb]].mashing)
			return hyb; /* mashing is allowed on this line, we take on it no matter what is the state of a line */
		if(!phUS_HybHasLockedLines(phUS, hyb))
			return hyb; /* no locked lines here, we take it here (will auto drop current calls) */
	}
	return 0;
}

function phUS_onPhoneLineDial(phUS, line)
{
	var num=gui_indi.numpadGetNumber(phUS);
	if(num=="")
		gui_indi.numpadRecall(phUS);
	else
		phUS.pp.LineCall(line, num, 0);
}

/*
** phUS_onPhoneLineKey
*/
function phUS_onPhoneLineKey(phUS, line, key_lt)
{
	var ln, hyb_use;

	if(!(line in phUS.lines)) return;
	ln=phUS.lines[line];

/* find hybrid to use */
	hyb_use=phUS_SelectHybridForLine(phUS, ln, key_lt);
	if(!hyb_use) return; // Button is inactive

	switch(ln.state)
	{
	case 'RINGING_IN':
	case 'ON_HOLD':
	case 'ON_HANDSET':
	case 'ON_HOLD_READY':
		phUS.pp.LineTake(line, hyb_use);
		break;
	case 'ON_AIR':
	case 'ON_AIR_DIALING':
		if(hyb_use==ln.hybrid)
			phUS.pp.LineLock(line);
		else
			phUS.pp.LineTake(line, hyb_use);
		break;
	case 'ON_AIR_LOCKED':
		if(hyb_use==ln.hybrid)
			phUS.pp.LineUnlock(line);
		else
		{
			phUS.pp.LineTake(line, hyb_use);
			if(hyb_use>2) phUS.pp.LineUnlock(line);
		}
		break;
	case 'IDLE':
		phUS.pp.LineSeize(line, hyb_use);
		break;
	case 'SEIZED':
		if(hyb_use!=ln.hybrid)
			phUS.pp.LineSeize(line, hyb_use);
		else
			;// do nothing phUS_onPhoneLineDial(phUS, line);
		break;
	case 'BUSY':
	case 'SEIZED_EW':
	case 'ON_HANDSET_EW':
	case 'USED_EW':
	case 'NONE':
	default:
		break;
	}
}

/*
** phUS_onPhoneDropKey
*/
function phUS_onPhoneDropKey(phUS, key_lt)
{
/* check if we want to drop seize first */
	var line, dropped=false;

	for(line in phUS.lines)
	{
		if(phUS.lines[line].state=='SEIZED')
		{
			phUS.pp.LineDrop(parseInt(line));
			dropped=true;
		}
	}
	if(!dropped)
	{
		if(phUS.mode24 && !key_lt)
			phUS_TakeLineClear(phUS); /* in 24 line mode right drop key clears Take Line mode */
		else
			phUS.pp.HybridDrop(key_lt?1:2);
	}
}

/*
** phUS_onFaderEvent
**
** US phone fader event
*/
function phUS_onFaderEvent(phUS, hybrid, event_id)
{
	log.info_f("phUS_onFaderEvent(ph, %d, %s)", hybrid, event_id);
	if(hybrid<0 || hybrid>phUS.num_hybrids) return;

	switch(event_id)
	{
	case 'phone':
		if(phUS_HybCanDrop(phUS, hybrid))
		{
			if(!phUS_TakeLineRelease(phUS, hybrid))
				phUS.pp.HybridDrop(hybrid);
		}
		else
			phUS_TakeLineToggle(phUS, hybrid);
		break;
	case 'hold':
		phUS.pp.HybridHold(hybrid);
		break;
	case 'drop':
		//if(!phUS_TakeLineRelease(phUS, hybrid))
		//	phUS.pp.HybridDrop(hybrid);
		break;
	case 'take':
		//phUS_TakeLineActivate(phUS, hybrid);
		break;
	case 'drop-lite': /* drops only seized fixed lines */
		//phUS_TakeLineRelease(phUS, hybrid);
		break;
	case 'ch-off': /* means channel went off */
	case 'pv-off': /* means preview went off */
		break;
	}
}

/*
** phUS_onFixedFaderEvent
**
** US phone fader event
*/
function phUS_onFixedFaderEvent(phUS, hybrid, event_id)
{
	var ln;

	log.info_f("phUS_onFixedFaderEvent(ph, %d, %s)", hybrid, event_id);
	if(hybrid<=0 || hybrid>phUS.num_fixed) return;
	if(!(hybrid in phUS.fixeds)) return;
	ln=phUS.fixeds[hybrid];

	switch(event_id)
	{
	case 'phone':
		switch(ln.state)
		{
		case 'RINGING_IN':
		case 'ON_HOLD':
		case 'ON_HANDSET':
		case 'ON_HOLD_READY':
			phUS.pp.FixedTake(hybrid);
			break;
		case 'IDLE':
			phUS.pp.FixedSeize(hybrid);
			break;
		case 'ON_AIR_LOCKED':
			phUS.pp.FixedUnlock(hybrid);
			break;
		case 'SEIZED':
			phUS.pp.FixedDrop(hybrid);
		/*
			var num=gui_indi.numpadGetNumber(phUS);
			if(num=="")
				phUS.pp.FixedDrop(hybrid);
			else
				phUS.pp.FixedCall(hybrid, num);*/
			break;
		case 'ON_AIR':
		case 'ON_AIR_DIALING':
			phUS.pp.FixedDrop(hybrid);
			break;
		}
		break;
	case 'hold':
		phUS.pp.FixedHold(hybrid);
		break;
	case 'call':
		if(ln.state=='SEIZED')
		{
			var num=gui_indi.numpadGetNumber(phUS);
			if(num=="")
				gui_indi.numpadRecall(phUS);
			else
				phUS.pp.FixedCall(hybrid, num);
		}
		break;
	case 'drop':
		//if(ln.state!='ON_HOLD') phUS.pp.FixedDrop(hybrid);
		break;
	case 'take':
	/*
		switch(ln.state)
		{
		case 'RINGING_IN':
		case 'ON_HOLD':
		case 'ON_HANDSET':
		case 'ON_HOLD_READY':
			phUS.pp.FixedTake(hybrid);
			break;
		case 'IDLE':
			phUS.pp.FixedSeize(hybrid);
			break;
		case 'ON_AIR_LOCKED':
			phUS.pp.FixedUnlock(hybrid);
			break;
		case 'SEIZED':
			var num=gui_indi.numpadGetNumber(phUS);
			if(num=="")
				gui_indi.numpadRecall(phUS);
			else
				phUS.pp.FixedCall(hybrid, num);
			break;
		}
	*/
		break;
	case 'drop-lite':
		//if(ln.state=='SEIZED') phUS.pp.FixedDrop(hybrid);
		break;
	case 'ch-off':
	case 'pv-off':
		break;
	}
}

/*
** onPhoneKeyDown/onPhoneKeyUp
**
** called on CallController module key press/release
*/
function onPhoneKeyDown(phone_id, key)
{
	if(!(phone_id in phUS_ConnInfo)) return;
	var phUS=phUS_ConnInfo[phone_id];

	if(key>=0 && key<12)
		phUS_onPhoneLineKey(phUS, key, (phUS.mode24 || !phUS.hyrev));
	else if(key>=12 && key<24)
	{
		if(phUS.mode24)
			phUS_onPhoneLineKey(phUS, key, true);
		else
			phUS_onPhoneLineKey(phUS, key-12, phUS.hyrev);
	}
	else switch(key)
	{
	case keys.PhnXfer:
		phUS.pp.Xfer();
		break;
	case keys.PhnBusyAll:
		phUS.pp.BlockAllToggle();
		break;
	case keys.PhnDropLt:
		phUS_onPhoneDropKey(phUS, !phUS.hyrev);
		break;
	case keys.PhnDropRt:
		phUS_onPhoneDropKey(phUS, phUS.hyrev);
		break;
	case keys.PhnNext:
		phUS.pp.Next();
		break;
	}
}
function onPhoneKeyUp(phone_id, key)
{
}

// ------------------------- * US NumPad Events * -------------------------

function phUS_onPadKey(key)
{
	var line;

/* find seized line and simulate key press */
	for(line in this.lines)
		if(this.lines[line].state=='SEIZED')
	{
		this.pp.LineDTMF(parseInt(line), key);
		return;
	}
	for(line in this.fixeds)
		if(this.fixeds[line].state=='SEIZED')
	{
		this.pp.FixedDTMF(parseInt(line), key);
		return;
	}
}

function phUS_onPadEnter()
{
	var line;

/* find seized line and simulate key press */
	for(line in this.lines)
		if(this.lines[line].state=='SEIZED')
	{
		phUS_onPhoneLineDial(this, parseInt(line));
		return;
	}
	for(line in this.fixeds)
		if(this.fixeds[line].state=='SEIZED')
	{
		phUS_onFixedFaderEvent(this, parseInt(line), 'call');
		return;
	}
}

function phUS_onPadClose()
{
	var line;

/* drop seized lines */
	for(line in this.lines)
		if(this.lines[line].state=='SEIZED')
			this.pp.LineDrop(parseInt(line));
	for(line in this.fixeds)
		if(this.fixeds[line].state=='SEIZED')
			this.pp.FixedDrop(parseInt(line));
}

// ------------------------- * Phone Events (from protocol backend) * -------------------------

/*
** phoneIndiStudio
**
** called by protocol backend when studio config is changed
** also means that connection is established
*/
function phoneIndiStudio(phone_id, num_lines, num_hybrids, num_fixed)
{
	log.info_f("phone-%d: studio cfg: %d lines, %d hybrids, %d fixed", phone_id, num_lines, num_hybrids, num_fixed);
	phUS_IndiStudioCfg(phone_id, num_lines, num_hybrids, num_fixed);
}

/*
** phoneIndiLineState
*/
function phoneIndiLineState(phone_id, line, state, hybrid, remote)
{
	log.info_f("phone-%d: line %d - %s %d [%s]", phone_id, line+1, state, hybrid, remote);
	phUS_IndiLineState(phone_id, line, state, hybrid, remote);
}

/*
** phoneIndiFixedState
*/
function phoneIndiFixedState(phone_id, hybrid, state, remote)
{
	log.info_f("phone-%d: fixed %d - %s [%s]", phone_id, hybrid, state, remote);
	if(phone_id in phUS_ConnInfo)
		phUS_IndiFixedState(phUS_ConnInfo[phone_id], hybrid, state, remote);
	else if(phone_id>=eu_offset && ((phone_id-eu_offset) in eu_data))
	{
	/* this is the Euro Phone Fader */
		var eu=eu_data[phone_id-eu_offset];

		if(hybrid in eu.hybrids)
			phEU_IndiLineState(phEU_ConnInfo[eu.hybrids[hybrid].eid], state, remote);
	}
}

// ------------------------- * EU Connection Aggregators * -------------------------
const eu_numchn=4;  /* total number of EU connections */
const eu_offset=16; /* first EU connection */
var eu_data=[];  /* EU reserved connections */

// user:pass@192.168.0.7/Fixed 1
function eu_ConnectVX(cid, url)
{
	var ci=phParseUrl(url);
	var n, proxy;

	if(!('host' in ci) || ci.host=="" || !('studio' in ci) || ci.studio=="") return null;
	if(!('user' in ci)) ci.user='user'; // default VX user
	if(!('pass' in ci)) ci.pass='';     // default VX password

	vxConnect(eu_offset+cid, ci.host, ci.user, ci.pass, ci.studio, "");
	proxy=
	{
		Seize: function(hybrid) {vxCmndFixedSeize(this.cid, hybrid);},
		Drop: function(hybrid) {vxCmndFixedDrop(this.cid, hybrid);},
		Hold: function(hybrid) {vxCmndFixedHold(this.cid, hybrid);},
		Call: function(hybrid, number) {vxCmndFixedCall(this.cid, hybrid, number);},
		Take: function(hybrid) {vxCmndFixedTake(this.cid, hybrid);},
		Lock: function(hybrid) {vxCmndFixedLock(this.cid, hybrid);},
		Unlock: function(hybrid) {vxCmndFixedUnlock(this.cid, hybrid);},
		DTMF: function(hybrid, keycode) {vxCmndFixedDTMF(this.cid, hybrid, keycode);},
		getState: function(hybrid) {return vxCmndFixedGetState(this.cid, hybrid);},

		close: function() {vxConnect(this.cid, "", "", "", "", "");},

		cid: eu_offset+cid
	};
	return proxy;
}

// user:pass@192.168.0.38/0
function eu_ConnectAP(cid, url)
{
	var ci=phParseUrl(url);
	var n, shskip, proxy;

	if(!('host' in ci) || ci.host=="") return null;
	if(!('user' in ci)) ci.user='telos'; // default Nx user
	if(!('pass' in ci)) ci.pass='telos'; // default Nx password
	if(!('studio' in ci) || !(shskip=parseInt(ci.studio)))
		shskip=0;

	apConnect(eu_offset+cid, ci.host, ci.user, ci.pass, "", "", "", shskip);
	proxy=
	{
		Seize: function(hybrid) {apCmndFixedSeize(this.cid, hybrid);},
		Drop: function(hybrid) {apCmndFixedDrop(this.cid, hybrid);},
		Hold: function(hybrid) {apCmndFixedHold(this.cid, hybrid);},
		Call: function(hybrid, number) {apCmndFixedCall(this.cid, hybrid, number);},
		Take: function(hybrid) {apCmndFixedTake(this.cid, hybrid);},
		Lock: function(hybrid) {apCmndFixedLock(this.cid, hybrid);},
		Unlock: function(hybrid) {apCmndFixedUnlock(this.cid, hybrid);},
		DTMF: function(hybrid, keycode) {},
		getState: function(hybrid) {return apCmndFixedGetState(this.cid, hybrid);},

		close: function() {apConnect(this.cid, "", "", "", "", "", "", 0);},

		map: function(hybrid, line)
		{
			apCmndFixedRegister(this.cid, hybrid, line);
			return true;
		},
		unmap: function(hybrid, line)
		{
			apCmndFixedRegister(this.cid, hybrid, null);
		},

		line_map: [],
		cid: eu_offset+cid
	};
	return proxy;
}

// user:pass@192.168.0.88/1
function eu_ConnectT2(cid, url)
{
	var ci=phParseUrl(url);
	var n, line, proxy;

	if(!('host' in ci) || ci.host=="") return null;
	if(!('user' in ci)) ci.user='Element'; // default T2 user
	if(!('pass' in ci)) ci.pass='Telos'; // default T2 password
	if(!('studio' in ci) || !(line=parseInt(ci.studio)))
		line=0;

	t2Connect(eu_offset+cid, ci.host, ci.user, ci.pass, line);
	proxy=
	{
		Seize: function(hybrid) {t2CmndFixedSeize(this.cid, hybrid);},
		Drop: function(hybrid) {t2CmndFixedDrop(this.cid, hybrid);},
		Hold: function(hybrid) {t2CmndFixedHold(this.cid, hybrid);},
		Call: function(hybrid, number) {t2CmndFixedCall(this.cid, hybrid, number);},
		Take: function(hybrid) {t2CmndFixedTake(this.cid, hybrid);},
		Lock: function(hybrid) {},
		Unlock: function(hybrid) {},
		DTMF: function(hybrid, keycode) {},
		getState: function(hybrid) {return t2CmndFixedGetState(this.cid, hybrid);},

		close: function() {t2Connect(this.cid, "", "", "", 0);},

		cid: eu_offset+cid
	};
	return proxy;
}

function eu_MakeConnection(cid, url)
{
	var host, user, pass, studio;
	var n;

	if(url=="") return null;

	if(url.substr(0, 3)=="vx:")
		return eu_ConnectVX(cid, url.substr(3));
	else if(url.substr(0, 3)=="ap:")
		return eu_ConnectAP(cid, url.substr(3));
	else if(url.substr(0, 3)=="t2:")
		return eu_ConnectT2(cid, url.substr(3));
	else
		return null;
}

/*
** eu_RegisterFader
*/
function eu_RegisterFader(eid, url, hybrid, line)
{
	var n, eu=null, free=null, proxy;

/* search for the phone slot to reuse */
	for(n=0; n<eu_numchn; n++)
	{
		if(!(n in eu_data))
		{
		/* free channel, remember */
			if(free==null) free=n;
			continue;
		}
	/* slot used, check if the same */
		if(eu_data[n].url==url)
		{
		/* found slot to reuse */
			eu=eu_data[n];
			break;
		}
	}
	if(eu==null)
	{
	/* no connection to reuse, start new */
		if(free==null)
		{
			log.warning_f("phone-eu: no free EU connection for %s:%d-%d on ch%02d", url, hybrid, line, eid);
			return false;
		}

		eu=
		{
			id: free,
			url: url,
			pp : eu_MakeConnection(free, url),
			hybrids: [],
			lines:   []
		};
		if(eu.pp==null) return false;
	/* link in */
		eu_data[free]=eu;
	}

/* register hybrid */
	if(hybrid in eu.hybrids)
	{
		log.warning_f("phone-eu: hybrid %d @ %s is in use on ch%02d", hybrid, url, eu.hybrids[hybrid].eid);
		return -1;
	}
	if(('map' in eu.pp) && !eu.pp.map(hybrid, line))
	{
		log.warning_f("phone-eu: hybrid %d @ %s map failed", hybrid, url);
		return -1;
	}
	eu.hybrids[hybrid]=
	{
		eid:  eid,  // EU phone id the hybrid is bound to
		line: line  // phone line bound to hybrid
	};
	proxy=
	{
		Seize: function() {this.pp.Seize(this.hybrid);},
		Drop: function() {this.pp.Drop(this.hybrid);},
		Hold: function() {this.pp.Hold(this.hybrid);},
		Call: function(number) {this.pp.Call(this.hybrid, number);},
		Take: function() {this.pp.Take(this.hybrid);},
		Lock: function() {this.pp.Lock(this.hybrid);},
		Unlock: function() {this.pp.Unlock(this.hybrid);},
		DTMF: function(keycode) {this.pp.DTMF(this.hybrid, keycode);},
		getState: function() {return this.pp.getState(this.hybrid);},

		close: function() {eu_UnRegister(this.index, this.hybrid);},

		hybrid: hybrid,
		pp: eu.pp,
		index: eu.id
	};
	return proxy;
}

/*
** eu_UnRegister
*/
function eu_UnRegister(euid, hybrid)
{
	if(!(euid in eu_data)) return;
	var eu=eu_data[euid];
	if(!(hybrid in eu.hybrids)) return;
	if('unmap' in eu.pp) eu.pp.unmap(hybrid, eu.hybrids[hybrid].line);
	delete eu.hybrids[hybrid];
	for(hybrid in eu.hybrids)
	{
		if('eid' in eu.hybrids[hybrid]) return; /* still have hybrids left */
	}
/* no more hybrids left */
	eu.pp.close();
	delete eu_data[euid];
}

// ------------------------- * EU style phones * -------------------------
var phEU_ConnInfo=[]; /* per fader connection info */

/*
phone settings are independent per-fader. if possible we should merge same host/studio to single connection

several types of backends are available:
t2: Telos2  - parameters: host; example t2:192.168.0.50/1
ap: Nx12    - parameters: host/sh-skip, line, hybrid; example ap:192.168.0.38/0, 2, 1
vx: TelosVX - parameters: host/studio, line; example vx:192.168.0.7/Fixed 1, 2
*/

/*
** phEU_UpdateFaderData
*/
function phEU_UpdateFaderData(channel, url, hybrid, line)
{
	var phEU;

/* disconnect previous first */
	if(channel in phEU_ConnInfo)
	{
	/* disconnect */
		phEU_ConnInfo[channel].pp.close();
	/* release all GUI Elements we might own */
		gui_indi.inringClose(phEU_ConnInfo[channel]);
		gui_indi.numpadRelease(phEU_ConnInfo[channel]);
		delete phEU_ConnInfo[channel];
	}
	if(url=="") return false;

	log.info_f("phone-eu: FaderData: %d, %s, %d, %d", channel, url, hybrid, line);

	phEU=
	{
		id: channel,
	/* dialpad servicing functions */
		onPadEnter: phEU_onPadEnter,
		onPadClose: phEU_onPadClose,
		onPadKey  : phEU_onPadKey,

		pp: eu_RegisterFader(channel, url, hybrid, line)
	};
	if(!phEU.pp) return false;
	phEU_ConnInfo[channel]=phEU;
	phEU.ln=phEU.pp.getState();
	ph_UpdateFixedFader(phEU.id, phEU.ln);
	return true;
}

/*
** phEU_onFaderEvent
**
** phone event from UI
*/
function phEU_onFaderEvent(phEU, event_id)
{
	var ln;

	log.info_f("phEU_onFaderEvent(ph, %s)", event_id);
	ln=phEU.ln;

	switch(event_id)
	{
	case 'phone':
		switch(ln.state)
		{
		case 'RINGING_IN':
		case 'ON_HOLD':
		case 'ON_HANDSET':
		case 'ON_HOLD_READY':
			phEU.pp.Take();
			break;
		case 'IDLE':
			phEU.pp.Seize();
			break;
		case 'ON_AIR_LOCKED':
			phEU.pp.Unlock();
			break;
		case 'SEIZED':
			phEU.pp.Drop();
		/*
			var num=gui_indi.numpadGetNumber(phUS);
			if(num=="")
				phEU.pp.Drop();
			else
				phEU.pp.Call(num);
		*/
			break;
		case 'ON_AIR':
		case 'ON_AIR_DIALING':
			phEU.pp.Drop();
			break;
		}
		break;
	case 'hold':
		phEU.pp.Hold();
		break;
	case 'call':
		if(ln.state=='SEIZED')
		{
			var num=gui_indi.numpadGetNumber(phEU);
			if(num=="")
				gui_indi.numpadRecall(phEU);
			else
				phEU.pp.Call(num);
		}
		break;
	case 'drop':
		//if(ln.state!='ON_HOLD') phEU.pp.Drop();
		break;
	case 'take':
	/*
		switch(ln.state)
		{
		case 'RINGING_IN':
		case 'ON_HOLD':
		case 'ON_HANDSET':
		case 'ON_HOLD_READY':
			phEU.pp.Take();
			break;
		case 'IDLE':
			phEU.pp.Seize();
			break;
		case 'ON_AIR_LOCKED':
			phEU.pp.Unlock();
			break;
		case 'SEIZED':
			var num=gui_indi.numpadGetNumber(phEU);
			if(num=="")
				gui_indi.numpadRecall(phEU);
			else
				phEU.pp.Call(num);
			break;
		}
	*/
		break;
	case 'drop-lite':
		//if(ln.state=='SEIZED') phEU.pp.Drop();
		break;
	case 'ch-off':
	case 'pv-off':
		break;
	}
}

/*
** phEU_IndiLineState
**
** line state change event from protocol backend
*/
function phEU_IndiLineState(phEU, state, remote)
{
	var icon=0, on_air=false;
	var ln;

	log.info_f("phEU_IndiLineState(ph, %s, %s)", state, remote);
	ln=phEU.ln;

	if(state==ln.state && remote==ln.remote) return;

/* process state change */
	if(state!=ln.state)
	{
		if(state=='RINGING_IN')
			gui_indi.inringOpen(phEU, remote);
		else if(ln.state=='RINGING_IN')
			gui_indi.inringClose(phEU);
		if(state=='SEIZED')
			gui_indi.numpadGrab(phEU);
		else if(ln.state=='SEIZED')
			gui_indi.numpadRelease(phEU);
	}

	ln.state=state;
	ln.remote=remote;
	ph_UpdateFixedFader(phEU.id, ln);
}

// ------------------------- * EU NumPad Events * -------------------------

function phEU_onPadKey(key)
{
	if(this.ln.state=='SEIZED') this.pp.DTMF(key);
}

function phEU_onPadEnter()
{
	if(this.ln.state=='SEIZED') phEU_onFaderEvent(this, 'call');
}

function phEU_onPadClose()
{
	if(this.ln.state=='SEIZED') this.pp.Drop();
}

// ------------------------- * User Phone Events * -------------------------

/*
** onPhoneFaderEvent
*/
function onPhoneFaderEvent(channel, event_id)
{
	var phUS, p;

/* check for EU phone bound to that channel first */
	if(channel in phEU_ConnInfo)
	{
	/* this channel is EuroPhone */
		phEU_onFaderEvent(phEU_ConnInfo[channel], event_id);
		return;
	}
/* search for US phone that owns this channel */
	for(p in phUS_ConnInfo)
	{
		if(!(channel in phUS_ConnInfo[p].faders)) continue;
		phUS=phUS_ConnInfo[p];
		if(phUS.faders[channel].fixed_line==0)
			phUS_onFaderEvent(phUS, phUS.faders[channel].hybrid, event_id);
		else
			phUS_onFixedFaderEvent(phUS, phUS.faders[channel].hybrid, event_id);
	/* use 'ch-off' for monitoring faders before loading next config */
		if(event_id=='ch-off' && phUS.faders[channel].waiting)
		{
			phUS.faders[channel].waiting=false;
			phUS_CheckWaitingFaders(phUS);
		}
	}
}

// ------------------------- * General Host Notifications * -------------------------

/*
** phoneMuteRinger
**
** need to mute ringer on all attached phones
*/
function phoneMuteRinger(mute)
{
	var phUS, p;

/* mute ringer of any phone connection */
/* TODO: need to remember that somehow to apply for new connections as well */
	for(p in phUS_ConnInfo)
	{
		phUS=phUS_ConnInfo[p];
		phUS.pp.Mute(mute);
	}
}
